<?php
class Module
{
	protected $db;
	private $resources = array();
	public function __construct($db)
	{
		$this->db = $db;

		if(!isset($modules)){
			foreach (glob(MODULES_DIR.'*') as $key => $value) {
				$class = explode('/',$value);
				$class = $class[count($class)-1];
				$modules[$class] = $key;
			}
		}
		if(isset($modules)){
			foreach($modules as $key => $value){
				$resource = (string) $key;
				if(!isset($this->resources[$resource])){
					if (class_exists($resource)) {
						$this->resources[$resource] = new $resource($db);
					}
				}
			}
		}

	}
	public function get($module){
		if(isset($this->resources[$module])) {
			return $this->resources[$module];
		}else{
			$this->resources[$module] = new $module($this->db);
			return $this->resources[$module];
		}
	}
	public function get_module_info($module)
	{
		$m = new $module($this->db);
		if(method_exists($m,'info')){
			return call_user_func(array($m , 'info'));
		}
	}
	public function trigger($place)
	{
		foreach ($this->resources as $key => $value) {
			if(method_exists($value,$place)){
				call_user_func(array($value, $place));
			}
		}
	}
}